% A user-defined function
%Compute p-value of the the one-sided optimal test POIS_{infty}
function result=BD_pv(m,q_t,k,rho)


K_4=gamma(k/2)/(pi^(1/2)*gamma((k-1)/2));

if k==2
  c=@(u) 2*rho*sqrt(q_t/(1-rho^2))*sin(u); 
  if m>-rho^2*q_t/(1-rho^2)/2
     func=@(u) chi2cdf(0.25*(sqrt(c(u).^2+4*m)-c(u)).^2,k);
     func2=@(u) func(u)-chi2cdf(0.25*(sqrt(c(u).^2+4*m)+c(u)).^2,k);
  end
  if m>=0
     result=1-K_4*integral(func,-pi/2,pi/2);
   elseif (m<0) & (m>-rho^2*q_t/(1-rho^2)/2) & rho>=0
     U=-sqrt(-2*m*(1-rho^2)/rho^2/q_t);
     result=1-K_4*integral(func2,-pi/2,asin(U));
   elseif (m<0) & (m>-rho^2*q_t/(1-rho^2)/2) & rho<0
     L=sqrt(-2*m*(1-rho^2)/rho^2/q_t);
     result=1-K_4*integral(func2,asin(L),pi/2);
   elseif m<=-rho^2*q_t/(1-rho^2)/2
     result=1;
  end
   
elseif k>2

   c=@(s2) 2*rho*sqrt(q_t/(1-rho^2))*s2;

   if m>-rho^2*q_t/(1-rho^2)/2
     func=@(s2) chi2cdf(0.25*(sqrt(c(s2).^2+4*m)-c(s2)).^2,k).* ...
                        (1-s2.^2).^((k-3)/2); 
     func2=@(s2) func(s2)-chi2cdf(0.25*(sqrt(c(s2).^2+4*m)+c(s2)).^2,k).* ...
                        (1-s2.^2).^((k-3)/2);
   end


   if m>=0
     result=1-K_4*integral(func,-1,1);
   elseif (m<0) & (m>-rho^2*q_t/(1-rho^2)/2) & rho>=0
     U=-sqrt(-2*m*(1-rho^2)/rho^2/q_t);
     result=1-K_4*integral(func2,-1,U);
   elseif (m<0) & (m>-rho^2*q_t/(1-rho^2)/2) & rho<0
     L=sqrt(-2*m*(1-rho^2)/rho^2/q_t);
     result=1-K_4*integral(func2,L,1);
   elseif m<=-rho^2*q_t/(1-rho^2)/2
     result=1;
   end
end
