% For Table SM-III, Table SM-IV
%Accompanies Power_com_max_beta0
%Adds results for AR and LM
%Has to be merged with results for POIS2 and CLR (obtained from Power_com_max_beta0) in output files

clear all

feature('accel','on')

I=10000; % number of replication
N=100; % sample size
Nsim=100000; %number of simulations when pvals are computed by simulations

%filename='output0_10_AR_LM.mat';
rho=0; %correlation between u and v, take values 0, .3, .5, .7, .9.
k=10; % number of IVs;
Lambda=[1 3 5 7 10 15 20]; % concentration paramter=Pi'Z'ZPi = lambda in the notes
%Lambda=[22 25]; large lambda for k=20, 40
%Lambda=[0.7 0.8 0.9 1]; small lambda for k=2, 5 with rho=.9.
beta_star=0;
omega_1=1;omega_2=1;

r_uv=rho/sqrt((1-rho^2));

Omega=[omega_1^2,rho;rho,omega_2^2];%reduced form covariance matrix
sigma_1=sqrt(omega_1^2-2*rho*beta_star+omega_2^2*beta_star^2); sigma_12=rho-omega_2^2*beta_star;sigma_2=omega_2;
Sigma=[sigma_1^2,sigma_12;sigma_12,sigma_2^2];

alpha=0.05;
cv_AR=chi2inv(1-alpha,k);
cv_LM=chi2inv(1-alpha,1);

Beta0=[-10000, -1000, -100, -50, -10, -7.5, -5, [-4:0.25:-0.25],[0.25:0.25:4],5,7.5,10,50,100,1000,10000]; %values under the null
Beta0=Beta0+0.00001*(Beta0==1); %with beta_0=1, c_beta_2star=infinity
Beta0=Beta0+0.00001*(Beta0==2); %with beta_0=2, c_beta_2star=infinity for rho=0.5
Beta0=Beta0-0.00001*(Beta0==-1); %there is a problem when rho=0

Lg=length(Beta0);
Lc=length(Lambda);
AR=zeros(I,Lg);
LM=zeros(I,Lg);
rej_AR=zeros(Lc,Lg,I);
rej_LM=zeros(Lc,Lg,I);
randseedoffset=81474; % was used in all simulations
tic
parfor i=1:I
    rng(randseedoffset+i, 'twister'); %to generate the same random sequences
    Z = randn(N,k); % Z are instruments
    epsilon= randn(N,2);
    epsilon1=epsilon(:,1);
    epsilon2 = epsilon(:,2);
    U = epsilon1;
    V_2 = sigma_12*epsilon1 + sqrt(1-sigma_12^2)*epsilon2;
    for c=1:Lc
    con=Lambda(c);
    Pi=ones(k,1)*sqrt(con/sum(sum(Z'*Z)));
    y_2 = Z*Pi + V_2;
    y_1 = y_2*beta_star+U;
    Y=[y_1,y_2]; V_1=U+V_2*beta_star;V=[V_1, V_2];
    for j=1:Lg;
        beta0=Beta0(j);
        b_0=[1,-beta0]'; a_0=[beta0,1]';
        S=(Z'*Z)^(-1/2)*Z'*Y*b_0/(b_0'*Omega*b_0)^(1/2);
        T=(Z'*Z)^(-1/2)*Z'*Y/Omega*a_0/(a_0'/Omega*a_0)^(1/2);
        Q_s=S'*S;
        Q_st=S'*T;
        Q_t=T'*T;
        AR(i,j)=Q_s;
        LM(i,j)=Q_st^2/Q_t;
        % comptue rejection frequency
        rej_AR(c,j,i)=AR(i,j)>cv_AR;
        rej_LM(c,j,i)=LM(i,j)>cv_LM;
        
    end
    end    
    
    
end

Rej_AR=mean(rej_AR,3);
Rej_LM=mean(rej_LM,3); %This is POIS2

toc
%implied correlation
Rho0=(Omega(1,2)-Beta0*Omega(2,2))./(Omega(1,1)-2*Beta0*Omega(1,2)+Beta0.^2*Omega(2,2)).^(0.5);
%save(filename,'Beta0','Lambda','k','rho','Rej_AR','Rej_LM','rej_AR','rej_LM');
