% A user-defined function
%computes the p-val of the conditional CLR test
%conditional on Q_T=q_t
%for k instruments
function result = CLR_pv(m,q_t,k)

K_4=gamma(k/2)/(pi^(1/2)*gamma((k-1)/2));

if k==2
    func=@(u) chi2cdf((q_t+m)./(1+(q_t/m).*(sin(u)).^2),k);
    result=1-2*K_4*integral(func,0,pi/2);
elseif k==3
    func=@(s2) chi2cdf((q_t+m)./(1+(q_t/m).*s2.^2),k);
    result=1-2*K_4*integral(func,0,1);
elseif k==4
    eps=0.02;
    result=1-2*K_4*chi2cdf((q_t+m)/(1+q_t/m*(1-eps/2)^2),k);
    
elseif k>4
    func=@(s2) chi2cdf((q_t+m)./(1+(q_t/m).*s2.^2),k).*(1-s2.^2).^((k-3)/2);
    result=1-2*K_4*integral(func,0,1);
else
    result=0;
 
end

end

