% A user-defined function
% compute psi2 function in WAP2 for very large Q_T
% See Supplemental Material 1 of AMY2018, equation(12.5) for the psi2 function
function Psi2 = psi2_h(D,q_t,lambda,k,check,sc)
  x0=sqrt(lambda.*D.^2.*q_t);
  x_s=(check<=700).*x0+(check>700); 
  x_l=(check>700).*x0+ (check<=700);
   
   Psi2=(check<=700).*exp(-lambda.*D.^2/2-max(sc)).*x_s.^(-k/2+1).*besseli(k/2-1,x_s)...
       + (check>700).*exp(x_l-lambda.*D.^2/2-max(sc)).*x_l.^(-k/2+0.5)/sqrt(2*pi);
   % When a component of x_s is 0, the first part of the
  % corresponding Psi2 is 0, similarly, when a compoenent of x_l is zero,
  % the second part of the corresponding Psi2 is 0. The first part is the
  % original Psi2 divided by max(sc), the second part is an approximation 
  %(appromixate the bessel function) and then divided by max(sc).
  
end

