% A user-defined function
% compute psi function in WAP2 for very large Q_T, used for simulating the
% critical value
% See Supplemental Material 1 of AMY2018, equation(12.5) for the psi function
function Psi = psi_a(C,D,Ksi,lambda,check,k,sc) 
  x=sqrt(lambda.*Ksi);
  %sc the rescaling term to prevent 0 or Inf
  if max(check)<=700
  Psi=exp(-lambda*(C^2+D^2)/2).*(x.^(-k/2+1)).*besseli(k/2-1,x);
  elseif max(check)>700
  Psi=exp(x-lambda*(C^2+D^2)/2-max(sc)).*x.^(-k/2+0.5)/sqrt(2*pi);
  end
end

