% A user-defined function
% compute psi function in WAP2 for very large Q_T
% See Supplemental Material 1 of AMY2018, equation(12.5) for the psi function
function Psi = psi_h(C,D,Ksi,lambda,check,k,sc)
  x0=sqrt(lambda.*Ksi);
  %sc the rescaling term to prevent 0 or Inf
  x_s=(check<=700).*x0+(check>700); 
  x_l=(check>700).*x0+ (check<=700);
  
  Psi=(check<=700).*exp(-lambda*(C^2+D^2)/2-max(sc)).*(x_s.^(-k/2+1)).*besseli(k/2-1,x_s)...
      +(check>700).*exp(x_l-lambda*(C^2+D^2)/2-max(sc)).*x_l.^(-k/2+0.5)/sqrt(2*pi);
  % x_s=x0 for x0 smaller than 700 and x_s=1 otherwise;
  % x_l=x0 for x0 larger than 700 and x_l=1 otherwise;
  % The first part is the
  % original Psi divided by max(sc), the second part is an approximation 
  %(appromixate the bessel function) and then divided by max(sc).
  
  
end

